proyectos_django/sena/sena/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('tienda.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

proyectos_django/sena/tienda/urls.py
from django.urls import path, include
from rest_framework.routers import DefaultRouter
from rest_framework.documentation import include_docs_urls

from . import views

router = DefaultRouter()
router.register(r'categoria', views.CategoriaViewSet)
router.register(r'producto', views.ProductoViewSet)
router.register(r'usuario', views.UsuarioViewSet)
router.register(r'venta', views.VentaViewSet)
router.register(r'ventadetalle', views.DetalleVentaViewSet)

app_name = "tienda"

urlpatterns = [
    # URLs para las api del proyecto
	path("api/1.0/", include(router.urls)),
	# path('api/1.0/docs/', include_docs_urls(title='Inventario API')),
 
    path("inicio/<str:abrir_off_canvas>/", views.index, name="index"),
    path("", views.login, name="login"),
    path("logout/", views.logout, name="logout"),

    path("listar_categorias/", views.categorias, name="listar_categorias"),
    path("form_cat/", views.categorias_crear_formulario, name="form_cat"),
    path("categorias_guardar/", views.categorias_guardar, name="categorias_guardar"),
    path("form_edit_cat/<int:id>/", views.categorias_editar_formulario, name="form_edit_cat"),
    path("categorias_eliminar/<int:id>/", views.categorias_eliminar, name="categorias_eliminar"),
    path("cat_buscar/", views.cat_buscar, name="cat_buscar"),

    path("productos/", views.productos, name="productos"),
    path("form_pro/", views.productos_formulario, name="form_pro"),
    path("productos_guardar/", views.productos_guardar, name="productos_guardar"),
    path("productos_eliminar/<int:id>/", views.productos_eliminar, name="productos_eliminar"),
    path("form_edit_pro/<int:id>/", views.productos_editar_formulario, name="form_edit_pro"),
    path("pro_buscar/", views.pro_buscar, name="pro_buscar"),

    path("cambiar_clave/<str:actual>", views.cambiar_clave, name="cambiar_clave"),
    path("guarda_clave/", views.guarda_clave, name="guarda_clave"),
    path("perfil/", views.ver_perfil, name="perfil"),

    # Carrito de compra...
    path("carrito_agregar/", views.carrito_agregar, name="carrito_agregar"),
    path("carrito_listar/", views.carrito_listar, name="carrito_listar"),
    path("carrito_eliminar_producto/<int:id>", views.carrito_eliminar_producto, name="carrito_eliminar_producto"),
    path("carrito_actualizar/", views.carrito_actualizar, name="carrito_actualizar"),
    path("establecer_venta/", views.establecer_venta, name="establecer_venta"),

    # envio de correo
    path("correo/", views.correo, name="correo"),

    # reportes
    path("reporte1_ventas/", views.reporte1_ventas, name="reporte1_ventas"),

]

proyectos_django/sena/tienda/models.py
from django.db import models

# Create your models here.
class Categoria(models.Model):
	nombre = models.CharField(max_length=50)
	descripcion = models.TextField(null=True, blank=True)

	def __str__(self):
		return f"{self.id} ----- {self.nombre}"

class Producto(models.Model):
	nombre = models.CharField(max_length=254)
	precio = models.IntegerField()
	fecha_compra = models.DateField()
	categoria = models.ForeignKey(Categoria, on_delete=models.DO_NOTHING)
	stock = models.IntegerField(default=1)
	foto = models.ImageField(null=True, blank=True, default='fotos_productos/default.png', upload_to='fotos_productos')

	def __str__(self):
		return f"{self.id} ----- {self.nombre} ${self.precio}"


class Usuario(models.Model):
	ROLES = (
		(1, 'Administrador'),
		(2, 'WebMaster'),
		(3, 'Usuario'),
	)
	foto = models.ImageField(null=True, blank=True, default='fotos/default.png', upload_to='fotos')
	nombre = models.CharField(max_length=50)
	apellido = models.CharField(max_length=50)
	nick = models.CharField(max_length=50)
	passwd = models.CharField(max_length=254)
	rol = models.IntegerField(choices=ROLES, default=3)

	def __str__(self):
		return f"{self.nick}"


class Venta(models.Model):
	fecha_venta = models.DateTimeField(auto_now=True)
	usuario = models.ForeignKey(Usuario, on_delete=models.DO_NOTHING)
	ESTADOS = (
		(1, 'Pendiente'),
		(2, 'Enviado'),
		(3, 'Rechazada'),
	)
	estado = models.IntegerField(choices=ESTADOS, default=1)

	def __str__(self):
		return f"{self.id}"

class DetalleVenta(models.Model):
	venta = models.ForeignKey(Venta, on_delete=models.DO_NOTHING)
	producto = models.ForeignKey(Producto, on_delete=models.DO_NOTHING)
	cantidad = models.IntegerField()
	precio_historico = models.IntegerField()

	def __str__(self):
		return f"{self.id} - {self.venta}"

proyectos_django/sena/tienda/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render, redirect
from django.urls import reverse

# Para tomar el from desde el settings
from django.conf import settings
from django.core.mail import BadHeaderError, EmailMessage

from django.db import IntegrityError, transaction

from django.db.models import Q
from django.contrib import messages
from .models import *

import os
from django.conf import settings
from django.conf.urls.static import static
import datetime
from .serializers import *
from rest_framework import viewsets

# Create your views here.


def login(request):
	if request.method == "POST":

		usuario = request.POST.get("nick")
		clave = request.POST.get("passwd")

		try:
			q = Usuario.objects.get(nick=usuario, passwd=clave)
			messages.success(request, "Bienvenido!!")
			# guardar nombre del rol y no su número...
			datos = {
				"rol": q.rol,
				"nombre_rol": q.get_rol_display(),
				"nombre": f"{q.nombre} {q.apellido}",
				"foto": q.foto.url if q.foto else "/media/fotos/default.png",
				"id": q.id
			}
			request.session["logueo"] = datos
			# variables del carrito de compra
			request.session["carrito"] = []
			request.session["cantidad_productos"] = 0
			# fin - variables del carrito de compra
			return HttpResponseRedirect(reverse("tienda:index", args=('no',)))

		except Usuario.DoesNotExist:
			messages.error(request, "Usuario o contraseña no válidos...")
			return render(request, "tienda/login.html")
	else:
		if request.session.get("logueo", False):
			return HttpResponseRedirect(reverse("tienda:index", args=('no',)))
		else:
			return render(request, "tienda/login.html")


def logout(request):
	try:
		del request.session["logueo"]
		del request.session["carrito"]
		del request.session["cantidad_productos"]
		messages.success(request, "Sesión cerrada correctamente!")
	except Exception as e:
		messages.error(request, f"Error: {e}")
	return HttpResponseRedirect(reverse("tienda:login"))


def index(request, abrir_off_canvas="no"):
	if abrir_off_canvas == "si":
		print("SI")
	else:
		print("NO")

	if request.session.get("logueo", False):
		c = Categoria.objects.all()

		# Detectar si viene paramétro id categoría para filtrar o no...
		filtro_categoria = request.GET.get("id")

		if filtro_categoria != None and filtro_categoria != '0':
			p = Producto.objects.filter(categoria_id = filtro_categoria)
			request.session["submenu"] = int(filtro_categoria)
		else:
			p = Producto.objects.all()
			request.session["submenu"] = 0

		contexto = {"categorias": c, "productos": p}
		return render(request, "tienda/index.html", contexto)
	else:
		return HttpResponseRedirect(reverse("tienda:login"))


def categorias(request):
	sesion = request.session.get("logueo", False)

	if sesion["nombre_rol"] != "Usuario":
		result = Categoria.objects.all()
		context = {"data": result}
		return render(request, "tienda/categorias/listar.html", context)
	else:
		messages.warning(request, "Usted no tiene permiso para acceder...")
		return HttpResponseRedirect(reverse("tienda:index", args=('no',)))

def categorias_crear_formulario(request):
	return render(request, "tienda/categorias/cat-form.html")


def categorias_guardar(request):
	if request.method == "POST":
		id = request.POST.get("id")
		nomb = request.POST.get("nombre")
		desc = request.POST.get("descripcion")

		if id == "":
			# crear
			try:
				cat = Categoria(
					nombre=nomb,
					descripcion=desc
				)
				cat.save()
				messages.success(request, "Guardado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")
		else:
			# actualizar
			try:
				q = Categoria.objects.get(pk=id)
				q.nombre = nomb
				q.descripcion = desc
				q.save()
				messages.success(request, "Actualizado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")

		return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))
	else:
		messages.warning(request, "No se enviaron datos...")
		return HttpResponseRedirect(reverse("tienda:form_cat", args=()))


def categorias_editar_formulario(request, id):
	q = Categoria.objects.get(pk=id)
	contexto = {"id": id, "data": q}
	return render(request, "tienda/categorias/cat-form.html", contexto)


def categorias_eliminar(request, id):
	try:
		q = Categoria.objects.get(pk=id)
		q.delete()
		messages.success(request, "Registro eliminado correctamente!!")
	except Exception as e:
		messages.error(request, f"Error: {e}")

	return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))


def cat_buscar(request):
	if request.method == "POST":

		buscar = request.POST.get("buscar")

		query = Categoria.objects.filter(
			Q(nombre__istartswith=buscar) |
			Q(descripcion__istartswith=buscar)
		)
		context = {"data": query, "buscado": buscar}
		return render(request, "tienda/categorias/listar.html", context)
	else:
		messages.warning(request, "No se enviaron datos...")
	return HttpResponseRedirect(reverse("tienda:listar_categorias", args=()))


def productos(request):
	registros = Producto.objects.all()
	contexto = {"data": registros}
	return render(request, "tienda/productos/listar.html", contexto)

def productos_formulario(request):
	query = Categoria.objects.all()
	contexto = {"categorias": query}
	return render(request, "tienda/productos/pro-form.html", contexto)


def upload_file(f, nuevo_nombre):
	with open(f"uploads/fotos_productos/{nuevo_nombre}", "wb+") as destination:
		for chunk in f.chunks():
			destination.write(chunk)


def productos_guardar(request):
	if request.method == "POST":
		foto = request.FILES.get("foto")
		if foto is not None:
			ahora = datetime.datetime.now()
			# Cambio fecha_hora ejemplo:	2024-03-18 15:28:27.109401
			# Por un string sin caracteres:	20240318_152827_109401
			ahora = str(ahora).replace("-", "").replace(" ", "_").replace(":", "").replace(".", "_")
			# Buscar la última aparición del punto para separar nombre de la extensión
			nombre_foto = foto.name.rsplit('.', 1)
			# Concateno: nombre + fecha_hora + extensión
			nuevo_nombre = f"{nombre_foto[0]}_{ahora}.{nombre_foto[1]}"
			# Envío a la función el objeto foto y el string del nuevo nombre para renombrar...
			upload_file(foto, nuevo_nombre)
		else:
			# Si no viene foto, uso la foto por defecto....
			nuevo_nombre = "default.png"

		id = request.POST.get("id")
		nomb = request.POST.get("nombre")
		precio = request.POST.get("precio")
		fecha_c = request.POST.get("fecha_compra")

		# foráneas, deben ser instancias de su clase
		cat = Categoria.objects.get(pk=request.POST.get("categoria"))

		if id == "":
			# crear
			try:
				pro = Producto(
					nombre=nomb,
					precio=precio,
					fecha_compra=fecha_c,
					categoria=cat,
					foto=f"fotos_productos/{nuevo_nombre}"
				)
				pro.save()
				messages.success(request, "Guardado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")
		else:
			# actualizar
			try:
				q = Producto.objects.get(pk=id)
				q.nombre = nomb
				q.precio = precio
				q.fecha_compra = fecha_c
				q.categoria = cat
				q.save()
				messages.success(request, "Actualizado correctamente!!")
			except Exception as e:
				messages.error(request, f"Error. {e}")

		return HttpResponseRedirect(reverse("tienda:productos", args=()))
	else:
		messages.warning(request, "No se enviaron datos...")
		return HttpResponseRedirect(reverse("tienda:form_pro", args=()))


def productos_eliminar(request, id):
	try:
		q = Producto.objects.get(pk=id)
		q.delete()

		print(f"======{settings.MEDIA_ROOT}/{q.foto}")
		if os.path.exists(f"{settings.MEDIA_ROOT}/{q.foto}"):

			if q.foto.url != "fotos_productos/default.png":
				os.remove(f"{settings.MEDIA_ROOT}/{q.foto}")
		else:
			messages.warning(request, "No existe la foto....")
		messages.success(request, "Registro eliminado correctamente!!")
	except Exception as e:
		messages.error(request, f"Error: {e}")

	return HttpResponseRedirect(reverse("tienda:productos", args=()))


def productos_editar_formulario(request, id):
	q = Producto.objects.get(pk=id)
	query = Categoria.objects.all()
	contexto = {"id": id, "data": q, "categorias": query}

	return render(request, "tienda/productos/pro-form.html", contexto)

def pro_buscar(request):
	if request.method == "POST":

		buscar = request.POST.get("buscar")

		query = Producto.objects.filter(nombre__icontains=buscar)

		context = {"data": query, "buscado": buscar}
		return render(request, "tienda/productos/listar.html", context)
	else:
		messages.warning(request, "No se enviaron datos...")
	return HttpResponseRedirect(reverse("tienda:productos", args=()))


def cambiar_clave(request, actual):
	contexto = {"actual": actual}
	return render(request, "tienda/usuarios/cambio_clave.html", contexto)


def guarda_clave(request):
	usuario = request.session.get("logueo", False)
	if usuario:
		if request.method == "POST":
			actual = request.POST.get("actual")
			clave1 = request.POST.get("clave1")
			clave2 = request.POST.get("clave2")
			try:
				q = Usuario.objects.get(pk=usuario["id"], passwd=actual)
				if clave1 == clave2:
					q.passwd = clave1
					q.save()
					messages.success(request, "Contraseña actualizada correctamente!!")
				else:
					messages.warning(request, "Nuevas Contraseñas no coinciden...")
			except Exception as e:
				messages.warning(request, f"Contraseña no válida.... {e}")
			return HttpResponseRedirect(reverse("tienda:cambiar_clave", kwargs={'actual': actual}))
	else:
		return HttpResponseRedirect(reverse("tienda:login"))


def ver_perfil(request):
	usuario = request.session.get("logueo", False)
	q = Usuario.objects.get(pk = usuario["id"])
	contexto = {"data": q}
	return render(request, "tienda/usuarios/perfil.html", contexto)


def carrito_agregar(request):
	if request.method == "POST":
		id_producto = request.POST.get("id")
		cantidad = int(request.POST.get("cantidad"))

		if not request.session.get("carrito", False):
			request.session["carrito"] = []

proyectos_django/sena/tienda/templates/tienda/productos/listar.html
{% extends 'tienda/base.html' %}

{% load static %}
{% load humanize %}

{% block titul %} Productos {% endblock %}

{% block contenedor %}
  <br>
  <div class="container-fluid">
    <a class="btn btn-success" href="{% url 'tienda:form_pro' %}">Crear</a>

  {% if data %}

    <form class="d-flex mt-2 mb-4" role="search" method="post" action="{% url 'tienda:pro_buscar' %}">
      {% csrf_token %}
      <input class="form-control me-2" type="search" placeholder="Buscar por nombre o descripción" aria-label="Search" name="buscar" value="{{ buscado }}">
      <button class="btn btn-outline-success" type="submit">Buscar</button>
    </form>

    <table class="table table-hover">
      <tr>
        <th>ID</th>
        <th>Nombre</th>
        <th>Foto</th>
        <th>Precio</th>
        <th>Fecha Compra</th>
        <th>Categoría</th>
        <th>Acciones</th>
      </tr>
    {% for i in data %}
      <tr>
        <td>{{ i.id }}</td>
        <td>{{ i.nombre }}</td>
        <td><img src="{{ i.foto.url }}" width="8%"></td>
        <td class="text-end">${{ i.precio|intcomma }}</td>
        <td>{{ i.fecha_compra }}</td><!-- |date:"SHORT_DATE_FORMAT"--><!-- |date:"D d M Y" --><!-- |date:"Y/m/d" -->
        <td>
          {% if i.categoria.nombre|upper == "SHORTS" %}
            <button type="button" class="btn btn-primary position-relative">
              {{ i.categoria.nombre|upper }}
              <span class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger">
                Nuevo
                <span class="visually-hidden">unread messages</span>
              </span>
            </button>
          {% else %}
            {{ i.categoria.nombre|upper }}
          {% endif %}
        </td>
        <td>
          <a href="{% url 'tienda:form_edit_pro' i.id %}" class="btn btn-info">Editar</a>
          <a href="javascript:confirmar_eliminar('{% url 'tienda:productos_eliminar' i.id %}');" class="btn btn-danger">Eliminar</a>
        </td>
      </tr>
    {% endfor %}
    </table>

    <nav aria-label="...">
      <ul class="pagination">
        <li class="page-item disabled">
          <a class="page-link">Previous</a>
        </li>
        <li class="page-item"><a class="page-link" href="#">1</a></li>
        <li class="page-item active" aria-current="page">
          <a class="page-link" href="#">2</a>
        </li>
        <li class="page-item"><a class="page-link" href="#">3</a></li>
        <li class="page-item">
          <a class="page-link" href="#">Next</a>
        </li>
      </ul>
    </nav>

  {% else %}
    <div class="card bg-warning mt-5 mb-5 p-1">
      NO hay registros....
    </div>
  {% endif %}
</div>
{% endblock %}

proyectos_django/sena/tienda/templates/tienda/productos/pro-form.html
{% extends 'tienda/base.html' %}

{% load static %}

{% block titul %} Crear Producto {% endblock %}

{% block contenedor %}

    {% if id %}
        <h3>Editar: {{ id }}</h3>
    {% endif %}

    <form method="post" action="{% url 'tienda:productos_guardar' %}" enctype="multipart/form-data">
        {% csrf_token %}

        <input type="hidden" name="id" value="{{ data.id }}">
        <label class="form-control">Foto:</label>
        <input type="file" name="foto" accept="image/*" />
        <br>
        <label class="form-control">Nombre:</label>
        <input type="text" required="" name="nombre" class="form-control" value="{{ data.nombre }}"/>
        <br>
        <label class="form-control">Precio:</label>
        <input type="number" required="" name="precio" class="form-control" value="{{ data.precio }}"/>
        <br>
        <label class="form-control">Fecha Compra:</label>
        <input type="date" required="" name="fecha_compra" class="form-control" value="{{ data.fecha_compra|date:'Y-m-d' }}"/>
        <br>
        <label class="form-control">Categoría:</label>
        <select name="categoria" required="" class="form-control">
            <option value="">Seleccione</option>
            {% for c in categorias %}
                <option value="{{ c.id }}" {% if data.categoria.id == c.id %}selected=""{% endif %} >{{ c.nombre }}</option>
            {% endfor %}
        </select>
        <br>
        <button type="submit" class="btn btn-info">
        {% if id %}
            Actualizar
        {% else %}
            Crear
        {% endif %}
        </button>
    </form>

{% endblock %}